var ads = new Ads();

function Ads() {
	var ads = this;
	this.admobid = null;
	this.isPrepared = false;
	this.adShowing = false;
	
	this.isAdShowing = function() {
		return ads.adShowing;
	};
	
	this.setAdShowing = function(value) {
		ads.adShowing = value;
	};
	
	this.prepare = function() {
		if (ads.isPrepared === true) {
			return;
		}
		
		if( /(android)/i.test(navigator.userAgent) ) { // for android
        	ads.admobid = {
            	interstitial: config.admob.android
        	};
    	} else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
        	ads.admobid = {
            	interstitial: config.admob.ios
        	};
		}

		ads.isPrepared = true;
	};
	
	this.initBannerAd = function(domElement) {
		ads.prepare();
		if(AdMob) AdMob.createBanner({
    		adId: ads.admobid.banner, 
    		position: AdMob.AD_POSITION.TOP_CENTER, 
    		autoShow: true,
			success: function(){},
    		error: function(){
        		console.log('failed to create banner');
    		}
		});
	};

	this.runInterstitial = function() {
		window.analytics.trackEvent('ads', 'ad-get-perc');

		if(config.admob.testing === true) {
			console.log("Ad Testing: Enabled");
			ads.prepareInterstitial();
			return;
		}

		$.ajax(config.apiPath + "php/perc.php", {
			type: 'GET',
			timeout: 6000,
			cache: true,
			success: function(result) {
				if(ads.showRandomAd(parseInt(result))) {
					ads.prepareInterstitial();
				}
			},
			error: function() {
				ads.prepareInterstitial();
			}
		});
	};
	
	this.prepareInterstitial = function() {
		window.analytics.trackEvent('ads', 'ad-request');

		ads.prepare();
		ads.setAdShowing(true);
		
		admob.interstitial.config({
			id: ads.admobid.interstitial,
			isTesting: config.admob.testing,
			autoShow: true
		});
		admob.interstitial.prepare();
	};
	
	this.showRandomAd = function(perc) {
		var num = Math.floor(Math.random() * 100) + 1;
		if (num <= perc) {
			return true;
		}
		return false;
	};
}
