var menuEvents = new MenuEvents();

function MenuEvents() {
	var menuEvents = this;

	this.compass = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		radarCompass.toggleRadarCompass();
	};

	this.helpfulHints = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		menuEvents.closeMenu();
		rainRadar.showPopUp();

		window.analytics.trackEvent('menu', 'menu-help');
	};

	this.reviewApp = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		menuEvents.closeMenu();

		ratings.reviewApp();
		window.analytics.trackEvent('menu', 'menu-review-app');	
	};

	this.emailSupport = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		window.analytics.trackEvent('menu', 'menu-support-email');
		window.open("mailto:" + config.supportEmail + "?subject=サポートをリクエスト (" + config.platform + " " + config.version + ")", "_system");

		window.analytics.trackEvent('menu', 'menu-support-email');
	};

	this.facebook = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		window.open(config.facebookLink, "_system", "location=no");
		window.analytics.trackEvent('menu', 'menu-facebook-page');
	};

	this.makePurchase = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		inAppPurchase.makePurchase();
		menuEvents.closeMenu();

		window.analytics.trackEvent('menu', 'menu-purchase');
	};

	this.restorePurchase = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();
	
		inAppPurchase.restorePurchase();
		menuEvents.closeMenu();

		window.analytics.trackEvent('menu', 'menu-restore-purchase');
	};

	this.useCurrentLocation = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		$('.radar-loader').show();
		$(".radar-select").removeClass("selected");
		$(".standard").addClass("selected");

		if($("#radar-container").hasClass("zoom")) {
			$(".multiplier").hide();
			$("#radar-container").removeClass("zoom");
			$("#radar-container").on("transitionend webkitTransitionEnd", function(){
				$("#radar-container").off("transitionend webkitTransitionEnd");
				locationManager.useCurrentLocation();
			});
		}
		else {
			locationManager.useCurrentLocation();
		}
		menuEvents.closeMenu();
		window.analytics.trackEvent('menu', 'menu-open-location');
	};

	this.openLocation = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		$('.radar-loader').show();
		$(".radar-select").removeClass("selected");
		$(".standard").addClass("selected");

		var location = {
			lat: $(this).data('lat'),
			long: $(this).data('long'),
			name: $(this).data('name')
		};

		if(rainRadar.imageRotator !== null) {
			rainRadar.imageRotator.isPaused = false;
			$("#play-button").removeClass("fa-play").addClass("fa-pause");
		}

		if($("#radar-container").hasClass("zoom")) {
			$(".multiplier").hide();
			$("#radar-container").removeClass("zoom");
			$("#radar-container").on("transitionend webkitTransitionEnd", function(){
				$("#radar-container").off("transitionend webkitTransitionEnd");
				locationManager.moveToLocation(location);
			});
		}
		else {
			locationManager.moveToLocation(location);
		}

		menuEvents.closeMenu();
		
		window.analytics.trackEvent('menu', 'menu-open-current-location');
	}

	this.editLocation = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		$('.location-list').fadeIn(0, function() {
			locationList.populateLocationList();
			$('.location-list').addClass('show');
			window.analytics.trackEvent('menu', 'menu-edit-locations');
		});
	};

	this.openMenu = function(ev) {
		$('.view-body').addClass('open-menu');
		$('#popup-toggle-img').removeClass('fa-bars').addClass('fa-close');
		$('.popup-toggle').off('touchstart');
		$('.view-body').on('touchstart', function(ev) {
			ev.stopPropagation();
			menuEvents.closeMenu();
		});
	};

	this.closeMenu = function(ev) {
		$('.view-body').removeClass('open-menu');
		$('#popup-toggle-img').removeClass('fa-close').addClass('fa-bars');
		$('.view-body').off('touchstart');

		$('.popup-toggle').on('touchstart', function(ev) {
			ev.stopPropagation();
			menuEvents.openMenu();
		});
	};
}

// Events
$('.compass').on('touchend', menuEvents.compass);
$('.helpful-hints').on('touchend', menuEvents.helpfulHints);
$('.review-app').on('touchend', menuEvents.reviewApp);
$('.email-support').on('touchend', menuEvents.emailSupport);
$('.facebook').on('touchend', menuEvents.facebook);
$(".make-purchase").on("touchend", menuEvents.makePurchase);
$(".restore-purchase").on("touchend", menuEvents.restorePurchase);
$('.use-current-location').on('touchend', menuEvents.useCurrentLocation);
$('.location').on('touchend', menuEvents.openLocation);
$('.edit-locations').on('touchend', menuEvents.editLocation);
