var ratings = new Ratings();

function Ratings() {
	var ratings = this;

	this.showRateDialog = function() {
		return localforage.getItem(config.storePrefix + "rate_dialog_done_v2").then(function(rateDialogDone) {
			if(rateDialogDone == "true") {
				return false;
			}
	
			return localforage.getItem(config.storePrefix + "startup_count").then(function(startupCount) {
				if(startupCount === null) {
					startupCount = 0;
				}

				if(ratings.showReviewCheck(startupCount)) {
					setTimeout(function() {
						localforage.setItem(config.storePrefix + "startup_count", startupCount + 1);
						ratings.promptForRatings();
					}, 5000);
					return true;
				}
				else {
					if(ratings.hasMaxedOutReviews(startupCount)) {
						localforage.setItem(config.storePrefix + "rate_dialog_done_v2", "true");
						return false;
					}

					localforage.setItem(config.storePrefix + "startup_count", startupCount + 1);
				}
				return false;
			});
		});
	}

	this.promptForRatings = function() {
		switch(config.platform) {
			case "ios":
				window.analytics.trackEvent('main', 'main-review-iosreview-prompt');
				ratings.promptForRatingsiOS();
				break;
			case "android":
				window.analytics.trackEvent('main', 'main-review-prompt-display');
				ratings.promptForRatingsAndroid();
				break;
		}
	};

	this.reviewApp = function() {
		switch(config.platform) {
			case "ios":
				window.analytics.trackEvent('main', 'main-review-iosreview-prompt');
				ratings.promptForRatingsiOS();
				break;
			case "android":
				window.analytics.trackEvent('main', 'main-review-prompt-display');
				window.open(config.reviewLink, "_system");
				break;
		}
	};

	this.promptForRatingsiOS = function() {
		inappreview.requestReview(null, null);
	};

	this.promptForRatingsAndroid = function() {
		window.analytics.trackEvent('main', 'main-review-prompt-display');	
	
		navigator.notification.confirm(config.appRateDialog.message, function(button) {
			switch(button) {
				case 2: // Rate 
					window.analytics.trackEvent('main', 'main-review-prompt-rate');	
					localforage.setItem(config.storePrefix + "rate_dialog_done_v2", "true");
					window.open(config.reviewLink, "_system");
					break;
				case 1: // Later
					window.analytics.trackEvent('main', 'main-review-prompt-later');
					localforage.setItem(config.storePrefix + "startup_count", 1);
					break;
				case 3: // No
					window.analytics.trackEvent('main', 'main-review-prompt-no');
					localforage.setItem(config.storePrefix + "rate_dialog_done_v2", "true");
					break;
			}
		}, config.appRateDialog.title, [config.appRateDialog.rateButtonLabel, config.appRateDialog.laterButtonLabel, config.appRateDialog.cancelButtonLabel]);
	};

	this.hasMaxedOutReviews = function(startupCount) {
		var showCount = config.appRateDialog.showCount;
		return startupCount > (3 * showCount);
	};

	this.showReviewCheck = function(startupCount) {
		var showCount = config.appRateDialog.showCount;
		return (startupCount !== 0 && startupCount <= (3 * showCount) && startupCount % showCount == 0);
	};

};